<template>
    <main>
        <div v-if="loading" class="loading">
            <v-icon left class="loading">fas fa-spinner fa-spin</v-icon>
            Loading...
        </div>
        <div v-if="message" class="error">{{message}}</div>

        <v-card v-if="person">
            <v-card-title>
                <h1>Person</h1>
            </v-card-title>
            <v-card-text>
                <v-container>
                    <v-row>
                        <v-col>
                            <table>
                                <tr>
                                    <th>Primary Key</th>
                                    <td>{{ this.person.id }}</td>
                                </tr>
                                <tr>
                                    <th>Name</th>
                                    <td>{{ this.person.name }}</td>
                                </tr>
                                <tr>
                                    <th>Age</th>
                                    <td>{{ this.person.age }}</td>
                                </tr>
                                <tr>
                                    <th>Gender</th>
                                    <td>{{ this.person.female ? 'fe' : '' }}male</td>
                                </tr>
                                <tr>
                                    <th>PostCode</th>
                                    <td>{{ this.person.postCode }}</td>
                                </tr>
                            </table>
                        </v-col>
                        <v-col>
                            <v-form v-if="formVisible" v-model="formValid">
                                <v-text-field v-model="personForm.name"
                                              label="Person Name" :rules="nameRule" :counter="32" :maxlength="32"
                                ></v-text-field>
                                <v-text-field v-model="personForm.age"
                                              label="Person Age" type="number" :min="18" :max="95" :rules="ageRule"
                                ></v-text-field>
                                <v-text-field v-model="personForm.postCode"
                                              label="Address Post Code" type="number" :rules="postCodeRule" :counter="10"
                                              :maxlength="10"
                                ></v-text-field>
                                <v-checkbox v-model="personForm.female" label="Is Female"></v-checkbox>
                            </v-form>
                        </v-col>
                    </v-row>
                </v-container>
            </v-card-text>

            <v-card-actions>
                <v-btn @click.prevent="edit(person)" :disabled="formVisible" color="primary">
                    <v-icon left>fas fa-edit</v-icon> Edit
                </v-btn>

                <v-btn @click="remove(person.id)" :disabled="formVisible" color="red" class="ml-3  ">
                    <v-icon left color="white">fas fa-trash-alt</v-icon> <span class="white--text">Remove</span>
                </v-btn>

                <v-btn @click="cancel" v-show="formVisible" color="secondary" class="ml-6 ">
                    <v-icon left color="white">fas fa-save</v-icon> Cancel
                </v-btn>

                <v-btn @click="save(person.id, personForm)" :disabled="!formValid" v-show="formVisible" color="success" class="ml-3 ">
                    <v-icon left >fas fa-save</v-icon> Save
                </v-btn>
            </v-card-actions>
        </v-card>
    </main>
</template>

<script>
    import axios from 'axios';

    const baseUrl = 'http://localhost:8000/api/v1';

    export default {
        name: 'person-view.page',
        data() {
            return {
                person: undefined,
                loading: false,
                message: undefined,
                formValid: false,
                formVisible: false,

                personForm: {
                    name: '',
                    age: '',
                    postCode: '',
                    female: ''
                },
                nameRule: [
                    v => !!v || 'Must not be empty',
                    v => (2 <= v.toString().length && v.toString().length <= 32) || 'Must have 2-32 chars'
                ],
                postCodeRule: [
                    v => !!v || 'Must not be empty',
                    v => (v && (3 <= v.toString().length && v.toString().length <= 10)) || 'Must have 3-10 chars'
                ],
                ageRule: [
                    v => !!v || 'Must not be empty',
                    v => (v && (18 <= +v && +v <= 95)) || 'Age must be in 18-95'
                ]
            }
        },

        mounted() {
            let id = this.$route.params.id;
            if (id === 'new') {
                this.create();
            } else if (id === 'any') {
                id = Math.floor(100 + Math.random() * 800);
                this.load(id);
            } else {
                this.load(id);
            }
        },

        methods: {
            load: async function (id) {
                this.loading = true;
                try {
                    const result = await axios.get(`${baseUrl}/person/${id}`);
                    this.person  = result.data;
                } catch (e) {
                    this.message = e.toString();
                } finally {
                    this.loading = false;
                }
            },

            create: function () {
                this.personForm  = {
                    name: '',
                    age: '',
                    postCode: '',
                    female: ''
                };
                this.person      = this.personForm;
                this.formVisible = true;
            },

            edit: function (p) {
                this.personForm  = {
                    name: p.name,
                    age: p.age,
                    postCode: p.postCode,
                    female: p.female
                };
                this.formVisible = true;
            },

            cancel: function () {
                this.formVisible = false;
                this.personForm  = {
                    name: '',
                    age: '',
                    postCode: '',
                    female: ''
                };
                if (this.person === undefined || this.person.id === undefined) {
                    this.$router.back();
                }
            },

            save: async function (id, p) {
                if (!this.formValid) return;

                this.loading = true;
                console.debug('id=%s, p=%o', id, JSON.stringify(p));
                try {
                    let result;
                    if (id === undefined) {
                        result = await axios.post(`${baseUrl}/person`, p);
                    } else {
                        result = await axios.put(`${baseUrl}/person/${id}`, p);
                    }
                    this.person      = result.data;
                    this.formVisible = false;
                } catch (e) {
                    this.message = e.toString();
                } finally {
                    this.loading = false;
                }
            },

            remove: async function (id) {
                this.loading = true;
                try {
                    await axios.delete(`${baseUrl}/person/${id}`);
                    this.$router.push('/person-list');
                } catch (e) {
                    this.message = e.toString();
                } finally {
                    this.loading = false;
                }
            }
        }
    }
</script>

<style scoped lang="scss">
    .loading {
        color: darkorange;
        font-size: 1.5rem;
        text-align: center;
    }

    .error {
        color: white;
        font-size: 1.5rem;
        text-align: center;
    }

    th {
        text-align: left;
        padding-right: 1em;
        color: #555;
        font-size: 1.5rem;
    }

    td {
        color: #333;
        font-size: 1.5rem;
    }
</style>
